--- dhcpcd-1.3.22-pl1/client.c	Sun Jan 20 18:46:27 2002
+++ dhcpcd-1.3.22-pl1-jeh1/client.c	Fri Apr 12 13:28:23 2002
@@ -661,25 +661,37 @@
 
   for (i=0;i<DhcpOptions.len[staticRoute];i+=8)
     {  /* setting static routes */
+      struct sockaddr_in *dstp; 
+      struct sockaddr_in *gwp; 
+      struct sockaddr_in *mskp; 
       memset(&rtent,0,sizeof(struct rtentry));
-      p                   =   (struct sockaddr_in *)&rtent.rt_dst;
-      p->sin_family	  =	  AF_INET;
-      memcpy(&p->sin_addr.s_addr,
+      dstp                =   (struct sockaddr_in *)&rtent.rt_dst;
+      dstp->sin_family	  =	  AF_INET;
+      memcpy(&dstp->sin_addr.s_addr,
       ((char *)DhcpOptions.val[staticRoute])+i,4);
-      p		          =	  (struct sockaddr_in *)&rtent.rt_gateway;
-      p->sin_family	  =	  AF_INET;
-      memcpy(&p->sin_addr.s_addr,
+      gwp	          =	  (struct sockaddr_in *)&rtent.rt_gateway;
+      gwp->sin_family	  =	  AF_INET;
+      memcpy(&gwp->sin_addr.s_addr,
       ((char *)DhcpOptions.val[staticRoute])+i+4,4);
-      p		          =	  (struct sockaddr_in *)&rtent.rt_genmask;
-      p->sin_family	  =       AF_INET;
-      p->sin_addr.s_addr  =	  0xffffffff;
+      mskp	          =	  (struct sockaddr_in *)&rtent.rt_genmask;
+      mskp->sin_family	  =       AF_INET;
+      rtent.rt_flags      =	  RTF_UP|RTF_GATEWAY;
+      if (IN_CLASSA(ntohl(dstp->sin_addr.s_addr))) {
+         mskp->sin_addr.s_addr  =  htonl(0xff000000);
+      } else if (IN_CLASSB(ntohl(dstp->sin_addr.s_addr))) {
+         mskp->sin_addr.s_addr  =  htonl(0xffff0000);
+      } else if (IN_CLASSC(ntohl(dstp->sin_addr.s_addr))) {
+         mskp->sin_addr.s_addr  =  htonl(0xffffff00);
+      } else {
+         mskp->sin_addr.s_addr  =  htonl(0xffffffff);
+         rtent.rt_flags     |= RTF_HOST;
+      }
 #ifdef OLD_LINUX_VERSION
       rtent.rt_dev	      =	  IfName;
 #else
       rtent.rt_dev	      =	  IfNameExt;
 #endif
       rtent.rt_metric     =	  1;
-      rtent.rt_flags      =	  RTF_UP|RTF_HOST|RTF_GATEWAY;
       if ( ioctl(dhcpSocket,SIOCADDRT,&rtent) )
 	syslog(LOG_ERR,"dhcpConfig: ioctl SIOCADDRT: %m\n");
     }
